import { useState } from 'react'

const Button = ({ handler, text }) => {
	return (
		<>
			<button onClick={handler}>{text}</button>
		</>
	)
}

const HighScore = ({ highScore, anecdotes, scores }) => {
	if (highScore === -1) {
		return (
			<p>No Highest Scoring Annecdote</p>
		)
	}
	return (
		<>
			<h2>The Highest Voted Annectdote</h2>
			<p>It has {scores[highScore]} votes</p>
			<p>{anecdotes[highScore]}</p>
		</>
	)
}

const App = () => {
	const anecdotes = [
		'If it hurts, do it more often.',
		'Adding manpower to a late software project makes it later!',
		'The first 90 percent of the code accounts for the first 10 percent of the development time...The remaining 10 percent of the code accounts for the other 90 percent of the development time.',
		'Any fool can write code that a computer can understand. Good programmers write code that humans can understand.',
		'Premature optimization is the root of all evil.',
		'Debugging is twice as hard as writing the code in the first place. Therefore, if you write the code as cleverly as possible, you are, by definition, not smart enough to debug it.',
		'Programming without an extremely heavy use of console.log is same as if a doctor would refuse to use x-rays or blood tests when diagnosing patients.',
		'The only way to go fast, is to go well.'
	]

	const [selected, setSelected] = useState(0)
	const [scores, setScores] = useState(Array(anecdotes.length).fill(0))
	const [highScore, setHigh] = useState(-1)

	const randomText = () => {
		const value = Math.floor(Math.random() * anecdotes.length)
		setSelected(value)
	}

	const VoteUp = () => {
		const copy = [...scores]
		copy[selected] += 1
		if (Math.max(...copy) === copy[selected]) {
			setHigh(selected)
		}
		setScores(copy)
	}

	return (
		<div>
			<Button handler={randomText} text="Randomize" />
			<Button handler={VoteUp} text="Vote" />
			<p>{anecdotes[selected]}</p>
			<p>Votes: {scores[selected]}</p>
			<HighScore anecdotes={anecdotes} highScore={highScore} scores={scores} />
		</div>
	)
}

export default App
